#import <appkit/appkit.h>
#import "GBListener.h"
#import <mach.h>
#import <sys/message.h>
#import <servers/netname.h>
extern port_t name_server_port;
extern id NXResponsibleDelegate();
@implementation  GBListener :Listener
{}
static NXRemoteMethod *remoteMethods = NULL;
#define REMOTEMETHODS 30
+ (void)initialize 
/* */
{
    if (!remoteMethods) {
	remoteMethods =
	(NXRemoteMethod *) malloc((REMOTEMETHODS+1)*sizeof(NXRemoteMethod));
	remoteMethods[0].key = 
	@selector(gbAddUser:userName:onHost:portNamed:);
	remoteMethods[0].types = "Iccc";
	remoteMethods[1].key = 
	@selector(gbUserAdded:userName:onHost:);
	remoteMethods[1].types = "icc";
	remoteMethods[2].key = 
	@selector(gbDropMe:);
	remoteMethods[2].types = "i";
	remoteMethods[3].key = 
	@selector(gbSendServerAll);
	remoteMethods[3].types = "";
	remoteMethods[4].key = 
	@selector(gbUser:allObjectsInArchive:length:);
	remoteMethods[4].types = "ib";
	remoteMethods[5].key = 
	@selector(gbUserRequestMarker:);
	remoteMethods[5].types = "i";
	remoteMethods[6].key = 
	@selector(gbUser:giveMarkerTo:);
	remoteMethods[6].types = "ii";
	remoteMethods[7].key = 
	@selector(gbUserGivesUpMarker:);
	remoteMethods[7].types = "i";
	remoteMethods[8].key = 
	@selector(gbUser:addObjectFromArchive:length:);
	remoteMethods[8].types = "ib";
	remoteMethods[9].key = 
	@selector(gbUser:insertObjectFromArchive:length:at:);
	remoteMethods[9].types = "ibi";
	remoteMethods[10].key = 
	@selector(gbUser:removeObjectAt:);
	remoteMethods[10].types = "ii";
	remoteMethods[11].key = 
	@selector(gbUser:replaceObjectAt:withArchive:length:);
	remoteMethods[11].types = "iib";
	remoteMethods[12].key = 
	@selector(gbUser:moveObjectFrom:toPosition:);
	remoteMethods[12].types = "iii";
	remoteMethods[13].key = 
	@selector(gbUserRecacheSelection:);
	remoteMethods[13].types = "i";
	remoteMethods[14].key = 
	@selector(gbUserGetSelection:);
	remoteMethods[14].types = "i";
	remoteMethods[15].key = 
	@selector(gbUserCacheSelection:);
	remoteMethods[15].types = "i";
	remoteMethods[16].key = 
	@selector(gbUserCacheGraphic:);
	remoteMethods[16].types = "i";
	remoteMethods[17].key = 
	@selector(gbUser:insertGraphic:length:);
	remoteMethods[17].types = "ib";
	remoteMethods[18].key = 
	@selector(gbUser:selectObjectAt:);
	remoteMethods[18].types = "ii";
	remoteMethods[19].key = 
	@selector(gbUser:deselectObjectAt:);
	remoteMethods[19].types = "ii";
	remoteMethods[20].key = 
	@selector(gbUser:changeBounds:to:length:);
	remoteMethods[20].types = "iib";
	remoteMethods[21].key = 
	@selector(gbUserDelete:);
	remoteMethods[21].types = "i";
	remoteMethods[22].key = 
	@selector(gbUserSelectAll:);
	remoteMethods[22].types = "i";
	remoteMethods[23].key = 
	@selector(gbUserDeselectAll:);
	remoteMethods[23].types = "i";
	remoteMethods[24].key = 
	@selector(gbUserBringToFront:);
	remoteMethods[24].types = "i";
	remoteMethods[25].key = 
	@selector(gbUserSendToBack:);
	remoteMethods[25].types = "i";
	remoteMethods[26].key = 
	@selector(gbUserGroup:);
	remoteMethods[26].types = "i";
	remoteMethods[27].key = 
	@selector(gbUserUnGroup:);
	remoteMethods[27].types = "i";
	remoteMethods[28].key = 
	@selector(gbUser:graphicsPerform:andDraw:);
	remoteMethods[28].types = "iii";
	remoteMethods[29].key = 
	@selector(gbUser:graphicsPerform:with:length:andDraw:);
	remoteMethods[29].types = "iibi";
	remoteMethods[REMOTEMETHODS].key = NULL;
    }
}
-(int)gbAddUser : (int *) uNum
	userName : (char *) uName
	onHost : (char *) hName
	portNamed : (char *) pName
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbAddUser:userName:onHost:portNamed:)))
	return [_NXd gbAddUser : uNum
		userName : uName
		onHost : hName
		portNamed : pName];
    return -1;
}

-(int)gbUserAdded : (int) uNum
	userName : (char *) uName
	onHost : (char *) hName
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUserAdded:userName:onHost:)))
	return [_NXd gbUserAdded : uNum
		userName : uName
		onHost : hName];
    return -1;
}

-(int)gbDropMe : (int) uNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbDropMe:)))
	return [_NXd gbDropMe : uNum];
    return -1;
}

-(int)gbSendServerAll
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbSendServerAll)))
	return [_NXd gbSendServerAll];
    return -1;
}

-(int)gbUser : (int) myNum
	allObjectsInArchive : (char *) data
	length : (int) len
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUser:allObjectsInArchive:length:)))
	return [_NXd gbUser : myNum
		allObjectsInArchive : data
		length : len];
    return -1;
}

-(int)gbUserRequestMarker : (int) uNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUserRequestMarker:)))
	return [_NXd gbUserRequestMarker : uNum];
    return -1;
}

-(int)gbUser : (int) myNum
	giveMarkerTo : (int) uNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUser:giveMarkerTo:)))
	return [_NXd gbUser : myNum
		giveMarkerTo : uNum];
    return -1;
}

-(int)gbUserGivesUpMarker : (int) uNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUserGivesUpMarker:)))
	return [_NXd gbUserGivesUpMarker : uNum];
    return -1;
}

-(int)gbUser : (int) myNum
	addObjectFromArchive : (char *) data
	length : (int) len
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUser:addObjectFromArchive:length:)))
	return [_NXd gbUser : myNum
		addObjectFromArchive : data
		length : len];
    return -1;
}

-(int)gbUser : (int) myNum
	insertObjectFromArchive : (char *) data
	length : (int) len
	at : (int) listNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUser:insertObjectFromArchive:length:at:)))
	return [_NXd gbUser : myNum
		insertObjectFromArchive : data
		length : len
		at : listNum];
    return -1;
}

-(int)gbUser : (int) myNum
	removeObjectAt : (int) listNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUser:removeObjectAt:)))
	return [_NXd gbUser : myNum
		removeObjectAt : listNum];
    return -1;
}

-(int)gbUser : (int) myNum
	replaceObjectAt : (int) listNum
	withArchive : (char *) data
	length : (int) len
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUser:replaceObjectAt:withArchive:length:)))
	return [_NXd gbUser : myNum
		replaceObjectAt : listNum
		withArchive : data
		length : len];
    return -1;
}

-(int)gbUser : (int) myNum
	moveObjectFrom : (int) listNum
	toPosition : (int) destNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUser:moveObjectFrom:toPosition:)))
	return [_NXd gbUser : myNum
		moveObjectFrom : listNum
		toPosition : destNum];
    return -1;
}

-(int)gbUserRecacheSelection : (int) myNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUserRecacheSelection:)))
	return [_NXd gbUserRecacheSelection : myNum];
    return -1;
}

-(int)gbUserGetSelection : (int) myNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUserGetSelection:)))
	return [_NXd gbUserGetSelection : myNum];
    return -1;
}

-(int)gbUserCacheSelection : (int) myNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUserCacheSelection:)))
	return [_NXd gbUserCacheSelection : myNum];
    return -1;
}

-(int)gbUserCacheGraphic : (int) myNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUserCacheGraphic:)))
	return [_NXd gbUserCacheGraphic : myNum];
    return -1;
}

-(int)gbUser : (int) myNum
	insertGraphic : (char *) data
	length : (int) len
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUser:insertGraphic:length:)))
	return [_NXd gbUser : myNum
		insertGraphic : data
		length : len];
    return -1;
}

-(int)gbUser : (int) myNum
	selectObjectAt : (int) listNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUser:selectObjectAt:)))
	return [_NXd gbUser : myNum
		selectObjectAt : listNum];
    return -1;
}

-(int)gbUser : (int) myNum
	deselectObjectAt : (int) listNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUser:deselectObjectAt:)))
	return [_NXd gbUser : myNum
		deselectObjectAt : listNum];
    return -1;
}

-(int)gbUser : (int) myNum
	changeBounds : (int) listNum
	to : (char *) data
	length : (int) len
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUser:changeBounds:to:length:)))
	return [_NXd gbUser : myNum
		changeBounds : listNum
		to : data
		length : len];
    return -1;
}

-(int)gbUserDelete : (int) myNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUserDelete:)))
	return [_NXd gbUserDelete : myNum];
    return -1;
}

-(int)gbUserSelectAll : (int) myNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUserSelectAll:)))
	return [_NXd gbUserSelectAll : myNum];
    return -1;
}

-(int)gbUserDeselectAll : (int) myNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUserDeselectAll:)))
	return [_NXd gbUserDeselectAll : myNum];
    return -1;
}

-(int)gbUserBringToFront : (int) myNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUserBringToFront:)))
	return [_NXd gbUserBringToFront : myNum];
    return -1;
}

-(int)gbUserSendToBack : (int) myNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUserSendToBack:)))
	return [_NXd gbUserSendToBack : myNum];
    return -1;
}

-(int)gbUserGroup : (int) myNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUserGroup:)))
	return [_NXd gbUserGroup : myNum];
    return -1;
}

-(int)gbUserUnGroup : (int) myNum
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUserUnGroup:)))
	return [_NXd gbUserUnGroup : myNum];
    return -1;
}

-(int)gbUser : (int) myNum
	graphicsPerform : (int) aSelector
	andDraw : (int) flag
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUser:graphicsPerform:andDraw:)))
	return [_NXd gbUser : myNum
		graphicsPerform : aSelector
		andDraw : flag];
    return -1;
}

-(int)gbUser : (int) myNum
	graphicsPerform : (int) aSelector
	with : (char *) argument
	length : (int) len
	andDraw : (int) flag
/* */
{
    id _NXd;
    if (_NXd = NXResponsibleDelegate(self,
	@selector(gbUser:graphicsPerform:with:length:andDraw:)))
	return [_NXd gbUser : myNum
		graphicsPerform : aSelector
		with : argument
		length : len
		andDraw : flag];
    return -1;
}

- (int) performRemoteMethod : (NXRemoteMethod *) method
                  paramList : (NXParamValue *) paramList {
/* */
    switch (method - remoteMethods) {
    case 0:
	return [self gbAddUser : &paramList[0].ival
		userName : paramList[1].bval.p
		onHost : paramList[2].bval.p
		portNamed : paramList[3].bval.p];
    case 1:
	return [self gbUserAdded : paramList[0].ival
		userName : paramList[1].bval.p
		onHost : paramList[2].bval.p];
    case 2:
	return [self gbDropMe : paramList[0].ival];
    case 3:
	return [self gbSendServerAll];
    case 4:
	return [self gbUser : paramList[0].ival
		allObjectsInArchive : paramList[1].bval.p
		length : paramList[1].bval.len];
    case 5:
	return [self gbUserRequestMarker : paramList[0].ival];
    case 6:
	return [self gbUser : paramList[0].ival
		giveMarkerTo : paramList[1].ival];
    case 7:
	return [self gbUserGivesUpMarker : paramList[0].ival];
    case 8:
	return [self gbUser : paramList[0].ival
		addObjectFromArchive : paramList[1].bval.p
		length : paramList[1].bval.len];
    case 9:
	return [self gbUser : paramList[0].ival
		insertObjectFromArchive : paramList[1].bval.p
		length : paramList[1].bval.len
		at : paramList[2].ival];
    case 10:
	return [self gbUser : paramList[0].ival
		removeObjectAt : paramList[1].ival];
    case 11:
	return [self gbUser : paramList[0].ival
		replaceObjectAt : paramList[1].ival
		withArchive : paramList[2].bval.p
		length : paramList[2].bval.len];
    case 12:
	return [self gbUser : paramList[0].ival
		moveObjectFrom : paramList[1].ival
		toPosition : paramList[2].ival];
    case 13:
	return [self gbUserRecacheSelection : paramList[0].ival];
    case 14:
	return [self gbUserGetSelection : paramList[0].ival];
    case 15:
	return [self gbUserCacheSelection : paramList[0].ival];
    case 16:
	return [self gbUserCacheGraphic : paramList[0].ival];
    case 17:
	return [self gbUser : paramList[0].ival
		insertGraphic : paramList[1].bval.p
		length : paramList[1].bval.len];
    case 18:
	return [self gbUser : paramList[0].ival
		selectObjectAt : paramList[1].ival];
    case 19:
	return [self gbUser : paramList[0].ival
		deselectObjectAt : paramList[1].ival];
    case 20:
	return [self gbUser : paramList[0].ival
		changeBounds : paramList[1].ival
		to : paramList[2].bval.p
		length : paramList[2].bval.len];
    case 21:
	return [self gbUserDelete : paramList[0].ival];
    case 22:
	return [self gbUserSelectAll : paramList[0].ival];
    case 23:
	return [self gbUserDeselectAll : paramList[0].ival];
    case 24:
	return [self gbUserBringToFront : paramList[0].ival];
    case 25:
	return [self gbUserSendToBack : paramList[0].ival];
    case 26:
	return [self gbUserGroup : paramList[0].ival];
    case 27:
	return [self gbUserUnGroup : paramList[0].ival];
    case 28:
	return [self gbUser : paramList[0].ival
		graphicsPerform : paramList[1].ival
		andDraw : paramList[2].ival];
    case 29:
	return [self gbUser : paramList[0].ival
		graphicsPerform : paramList[1].ival
		with : paramList[2].bval.p
		length : paramList[2].bval.len
		andDraw : paramList[3].ival];
    default:
	return [super performRemoteMethod : method paramList : paramList];
    }
}
- (NXRemoteMethod *) remoteMethodFor: (SEL) aSel {
/* */
    NXRemoteMethod *rm;
    if (rm = NXRemoteMethodFromSel(aSel,remoteMethods))
        return rm;
    return [super remoteMethodFor : aSel];
}
@end
